package com.zhaoliangsz.grainsearch.controller;


import org.springframework.web.bind.annotation.RequestMapping;
import lombok.extern.slf4j.Slf4j;
import javax.annotation.Resource;
import com.zhaoliangsz.grainsearch.service.IAskLeaveService;
import org.springframework.web.bind.annotation.*;
import com.zhaoliangsz.grainsearch.basic.exception.ServiceException;
import com.zhaoliangsz.grainsearch.basic.result.PageResult;
import com.zhaoliangsz.grainsearch.domain.entity.AskLeave;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zyw
 * @since 2024-02-18 10:28:10
 */
@RestController
@Slf4j
@RequestMapping("/v1/askLeave")
public class AskLeaveController {
    @Resource
    private IAskLeaveService myIAskLeaveService;
    /**
     * 获取AskLeave
     * @return
     */
    @GetMapping
    public PageResult<AskLeave> queryAskLeaveList(AskLeave queryAskLeave) throws ServiceException {
        log.info("[AskLeaveController.queryAskLeaveList]获取AskLeave列表开始参数:{}",queryAskLeave);
        PageResult<AskLeave> page = myIAskLeaveService.queryAskLeaveList(queryAskLeave);
        log.info("[AskLeaveController.queryAskLeaveList]获取AskLeave列表结束结果:{}",page);
        return page;
    }
    /**
     * 新增AskLeave
     * @return
     */
    @PostMapping
    public String addAskLeave(@RequestBody AskLeave addAskLeave) throws ServiceException {
        log.info("[AskLeaveController.addAskLeave]新增AskLeave开始addAskLeave:{}",addAskLeave);
        String result = myIAskLeaveService.addAskLeave(addAskLeave);
        log.info("[AskLeaveController.addAskLeave]新增AskLeave结束结果:{}",result);
        return result;
    }
    /**
     * 编辑AskLeave
     * @return
     */
    @PutMapping
    public String editAskLeave(@RequestBody AskLeave editAskLeave) throws ServiceException {
        log.info("[AskLeaveController.editAskLeave]编辑AskLeave开始参数:{}",editAskLeave);
        String result = myIAskLeaveService.editAskLeave(editAskLeave);
        log.info("[AskLeaveController.editAskLeave]编辑AskLeave结束结果:{}",result);
        return result;
    }
    /**
     * 删除AskLeave
     * @return
     */
    @DeleteMapping
    public String deleteAskLeave(@RequestBody AskLeave deleteAskLeave) throws ServiceException {
        log.info("[AskLeaveController.deleteAskLeave]删除AskLeave开始参数:{}",deleteAskLeave);
        String result = myIAskLeaveService.deleteAskLeave(deleteAskLeave);
        log.info("[AskLeaveController.deleteAskLeave]删除AskLeave结束结果:{}",result);
        return result;
    }
}

