package com.zhaoliangsz.grainsearch.controller;


import org.springframework.web.bind.annotation.RequestMapping;
import lombok.extern.slf4j.Slf4j;
import javax.annotation.Resource;
import com.zhaoliangsz.grainsearch.service.ISzgcColorService;
import org.springframework.web.bind.annotation.*;
import com.zhaoliangsz.grainsearch.basic.exception.ServiceException;
import com.zhaoliangsz.grainsearch.basic.result.PageResult;
import com.zhaoliangsz.grainsearch.domain.entity.SzgcColor;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zyw
 * @since 2024-04-03 13:22:38
 */
@RestController
@Slf4j
@RequestMapping("/v1/szgcColor")
public class SzgcColorController {
    @Resource
    private ISzgcColorService myISzgcColorService;
    /**
     * 获取SzgcColor
     * @return
     */
    @GetMapping
    public PageResult<SzgcColor> querySzgcColorList(SzgcColor querySzgcColor) throws ServiceException {
        log.info("[SzgcColorController.querySzgcColorList]获取SzgcColor列表开始参数:{}",querySzgcColor);
        PageResult<SzgcColor> page = myISzgcColorService.querySzgcColorList(querySzgcColor);
        log.info("[SzgcColorController.querySzgcColorList]获取SzgcColor列表结束结果:{}",page);
        return page;
    }
    /**
     * 新增SzgcColor
     * @return
     */
    @PostMapping
    public String addSzgcColor(@RequestBody SzgcColor addSzgcColor) throws ServiceException {
        log.info("[SzgcColorController.addSzgcColor]新增SzgcColor开始addSzgcColor:{}",addSzgcColor);
        String result = myISzgcColorService.addSzgcColor(addSzgcColor);
        log.info("[SzgcColorController.addSzgcColor]新增SzgcColor结束结果:{}",result);
        return result;
    }
    /**
     * 编辑SzgcColor
     * @return
     */
    @PutMapping
    public String editSzgcColor(@RequestBody SzgcColor editSzgcColor) throws ServiceException {
        log.info("[SzgcColorController.editSzgcColor]编辑SzgcColor开始参数:{}",editSzgcColor);
        String result = myISzgcColorService.editSzgcColor(editSzgcColor);
        log.info("[SzgcColorController.editSzgcColor]编辑SzgcColor结束结果:{}",result);
        return result;
    }
    /**
     * 删除SzgcColor
     * @return
     */
    @DeleteMapping
    public String deleteSzgcColor(@RequestBody SzgcColor deleteSzgcColor) throws ServiceException {
        log.info("[SzgcColorController.deleteSzgcColor]删除SzgcColor开始参数:{}",deleteSzgcColor);
        String result = myISzgcColorService.deleteSzgcColor(deleteSzgcColor);
        log.info("[SzgcColorController.deleteSzgcColor]删除SzgcColor结束结果:{}",result);
        return result;
    }
}

