package com.zhaoliangsz.grainsearch.service.impl;

import com.zhaoliangsz.grainsearch.domain.entity.SzgcColor;
import com.zhaoliangsz.grainsearch.mapper.SzgcColorMapper;
import com.zhaoliangsz.grainsearch.service.ISzgcColorService;
import com.baomidou.mybatisplus.extension.service.IService;
import org.springframework.stereotype.Service;
import com.zhaoliangsz.grainsearch.basic.exception.ServiceException;
import com.zhaoliangsz.grainsearch.basic.result.PageResult;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.transaction.annotation.Transactional;
import com.zhaoliangsz.grainsearch.basic.exception.ExceptionDefinition;
/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zyw
 * @since 2024-04-03 13:22:38
 */
@Slf4j
@Service
public class SzgcColorServiceImpl extends ServiceImpl<SzgcColorMapper, SzgcColor> implements ISzgcColorService {
    @Override
    public PageResult<SzgcColor> querySzgcColorList(SzgcColor querySzgcColor) throws ServiceException{
        try{
            Map<String,Object> pageView = new HashMap<>();
            pageView.put("startRecord",(querySzgcColor.getCurrentPage()-1)
            *querySzgcColor.getPageSize());
            pageView.put("pageSize",querySzgcColor.getPageSize());
            pageView.put("currentPage",querySzgcColor.getCurrentPage());
            Integer dataCount=baseMapper.getCountByCondition(pageView);
            List<SzgcColor>dataList=baseMapper.getListByCondition(pageView);
            return new PageResult<>(dataList==null?new ArrayList<>():dataList,dataCount==null?0:dataCount);
        }
        catch(Exception ex){
            log.error("[SzgcColorServiceImpl.querySzgcColorList]异常:{}",ex.toString());
            throw new ServiceException(ExceptionDefinition.QUERY_DATA_EXCEPTION);
        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String addSzgcColor(SzgcColor addSzgcColor) throws ServiceException {
        boolean flag = this.save(addSzgcColor);
        if(flag){
            return "ok";
        }
        else{
            throw new ServiceException(ExceptionDefinition.ADD_DATA_EXCEPTION);
        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String editSzgcColor(SzgcColor editSzgcColor) throws ServiceException {
        boolean flag = this.updateById(editSzgcColor);
        if(flag){
            return "ok";
        }
        else{
            throw new ServiceException(ExceptionDefinition.EDIT_DATA_EXCEPTION);
        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String deleteSzgcColor(SzgcColor deleteSzgcColor) throws ServiceException {
        boolean flag = this.removeById(deleteSzgcColor);
        if(flag){
            return "ok";
        }
        else{
            throw new ServiceException(ExceptionDefinition.DELETE_DATA_EXCEPTION);
        }
    }
}
